/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.pb162.contactsexample.catalog;

import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;
import java.util.SortedSet;
import java.util.TreeMap;
import java.util.TreeSet;

/**
 *
 * @author xmirek
 */
public class CatalogImpl implements ContactsCatalog{

    private SortedMap<Person, Set<PhoneNumber>> numbersForPerson =
            new TreeMap<Person, Set<PhoneNumber>>();
    private SortedSet<Person> personsAccordingToSurname = new TreeSet<Person>(new PersonSurnameComp());
    private Map<PhoneNumber, Person> personForNumer = new HashMap<PhoneNumber, Person>();

    public SortedSet<Person> getAllPersonsAccordingToSurname() {
        return Collections.unmodifiableSortedSet(personsAccordingToSurname);
    }

    public SortedSet<Person> getAllPersonsAccordingToFirstName() {
        return Collections.unmodifiableSortedSet((SortedSet<Person>)
                numbersForPerson.keySet());
    }

    public Collection<PhoneNumber> getNumbersForOfPersonAccordingToType(Person person) {
        
    }

    public Collection<PhoneNumber> getNumbersForOfPersonAccordingToNumber(Person person) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void addPerson(Person newPerson) {
        numbersForPerson.put(newPerson, new HashSet<PhoneNumber>());
        personsAccordingToSurname.add(newPerson);
    }

    public void addNumber(Person forPerson, PhoneNumber newNumber) {
        numbersForPerson.get(forPerson).add(newNumber);
    }

    public void deletePerson(Person person) {
        numbersForPerson.remove(person);
        personsAccordingToSurname.remove(person);
    }

    public void deleteNumber(PhoneNumber number) {
        
    }

    public Person getPersonForNumber(PhoneNumber number) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public boolean containsNumber(PhoneNumber number) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public boolean contactnsPerson(Person person) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void save(String filePath) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void load(String filePath) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

}
